---
title: 'SyntaxError: Unexpected ''#'' used outside of class body'
slug: Web/JavaScript/Reference/Errors/Hash_outside_class
tags:
  - Error
  - JavaScript
  - Reference
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "Unexpected '#' used outside of class body" occurs when a hash ("#") is encountered in an unexpected context, most notably <a href="/en-US/docs/Web/JavaScript/Reference/Classes/Private_class_fields">outside of a class declaration</a>. Hashes are valid at the beginning of a file as a <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar">hashbang comment</a>, or inside of a class as part of a private field. You may encounter this error if you forget the quotation marks when trying to access a DOM identifier as well.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox notranslate">SyntaxError: Unexpected '#' used outside of class body.
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>We encountered a `#` somewhere unexpected. This may be due to code moving around and no longer being part of a class, a hashbang comment found on a line other than the first line of a file, or accidentally forgetting the quotation marks around a DOM identifier.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Missing_quotation_marks">Missing quotation marks</h3>

<p>For each case, there might be something slightly wrong. For example</p>

<pre class="brush: js example-bad notranslate">document.querySelector(#some-element)
</pre>

<p>This can be fixed via</p>

<pre class="brush: js example-good notranslate">document.querySelector("#some-element")
</pre>

<h3 id="Outside_of_a_class">Outside of a class</h3>

<pre class="brush: js example-bad notranslate">class ClassWithPrivateField {
  #privateField

  constructor() {
  }
}

this.#privateField = 42
</pre>

<p>This can be fixed by moving the private field back into the class</p>

<pre class="brush: js example-good notranslate">class ClassWithPrivateField {
  #privateField

  constructor() {
    this.#privateField = 42
  }
}
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>
  <p>{{jsxref("SyntaxError")}}</p>
 </li>
</ul>
